/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#include <stdio.h>
#include "glilo_common.h"
#include "glilo_section_tree.h"
#include "glilo_section.h"
#include "glilo_keyword.h"
#include "glilo_sig.h"
#include "glilo_dialog_input.h"

#include "../lilocommon/message.h"
#include "../lilocommon/lilo_options.h"
#include "../lilocommon/scan.h"
#include "../lilocommon/lilo_help.h"
#include "../lilocommon/memwatch.h"
#include "../lilocommon/lilo_common.h"


/*
 * Called to clean up everything in the ctree and clists
 */
void clean_things_up (GLILO_GUI *gui)
{
  if (gui->lilodata != NULL)
    free_lilo_data(gui->lilodata);
  gui->lilodata = NULL;

  remove_ctree_data(gui);

  /* Remove all data from clist too */
  remove_data_from_section(GTK_CLIST(gui->sectionlist));

  /* Remove the crap from the keylist */
  remove_data_from_keylist(GTK_CLIST(gui->keylist));
  
  hide_illegal_buttons(gui);
}

/*
 * Loads paths to pixmaps...
 */
void load_paths()
{
  add_possible_path ("/usr/share/glilo");
  add_possible_path ("/usr/local/share/glilo");
  add_possible_path ("./");
  add_possible_path ("../lilocommon/");
}

/*
 * Free the alloced memory
 */
void remove_paths()
{
  free_possible_paths();
}

