/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#include <string.h>
#include <libintl.h>
#include "pixmap_stuff.h"
#include "glilo_dialog_input.h"

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>


static int okay_hit;

int dialog_was_okay_hit()
{
  return okay_hit;
}

void
on_Exit_Dialog(GtkWidget *widget)
{
  gtk_widget_destroy (widget);
  gtk_main_quit();
  okay_hit = 0;
}

void
on_Okay (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy (GTK_WIDGET(data));
  gtk_main_quit();
  okay_hit = 1; /* Needs to have it last since widget_destroy() calls on_Exit_..*/
}

void dialog_input_show (gchar *message, gchar *title)
{
  GtkWidget *dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox2;
  GtkWidget *pixmap1;
  GtkWidget *label3;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *buttonleft;
  GtkWidget *buttonright;
  /*GtkAccelGroup *accel_group;*/

  okay_hit = 0;
  dialog = gtk_dialog_new ();
  gtk_window_set_modal (GTK_WINDOW(dialog),TRUE);

  gtk_widget_set_usize (dialog, 300, 150); 
  gtk_window_set_title (GTK_WINDOW(dialog),title);

  /* If user hits the destroy window button ... */
  gtk_signal_connect (GTK_OBJECT(dialog),"delete_event",
                      GTK_SIGNAL_FUNC(on_Exit_Dialog),
                      GTK_OBJECT(dialog));

  
  gtk_signal_connect (GTK_OBJECT(dialog),"destroy_event",
                      GTK_SIGNAL_FUNC(on_Exit_Dialog),
                      GTK_OBJECT(dialog));

  
  /* accelllllls
     accel_group = gtk_accel_group_new ();

     gtk_window_add_accel_group (GTK_WINDOW (dialog), accel_group);
     gtk_widget_add_accelerator (dialog, "destroy", accel_group,
     GDK_Escape, 0, GTK_ACCEL_VISIBLE);

     gtk_window_set_policy (GTK_WINDOW (dialog), FALSE, FALSE, FALSE);

  end accels */
  dialog_vbox1 = GTK_DIALOG (dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox2, TRUE, TRUE, 0);

  pixmap1 = create_pixmap (dialog, "glilo_query.xpm");
  if (pixmap1 != NULL) { /* We won't show the pixmap if we can't load it */
    gtk_widget_show (pixmap1);
    gtk_box_pack_start (GTK_BOX (hbox2), pixmap1, FALSE, TRUE, 10);
  }

  label3 = gtk_label_new (message);
  gtk_widget_show (label3);
  gtk_label_set_line_wrap(GTK_LABEL(label3),TRUE);
  gtk_box_pack_start (GTK_BOX (hbox2), label3, TRUE, TRUE, 0);
  gtk_widget_set_usize (label3, 200, 100); 

  dialog_action_area1 = GTK_DIALOG (dialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  buttonleft = gtk_button_new_with_label (gettext("Okay"));
  gtk_widget_show (buttonleft);
  gtk_box_pack_start (GTK_BOX (hbox1), buttonleft, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT (buttonleft), "clicked",
                     GTK_SIGNAL_FUNC (on_Okay), dialog);

  buttonright = gtk_button_new_with_label (gettext("Cancel"));
  gtk_widget_show (buttonright);
  gtk_box_pack_start (GTK_BOX (hbox1), buttonright, TRUE, TRUE, 0);
  gtk_widget_grab_focus (buttonright);
  gtk_signal_connect_object (GTK_OBJECT (buttonright), "clicked",
                             GTK_SIGNAL_FUNC (on_Exit_Dialog),
                             GTK_OBJECT(dialog));

  
  gtk_widget_show (dialog);
  gtk_main(); /* Enter a new event loop */
}



