/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#include <gtk/gtk.h>
#include <libintl.h>
#include "glilo_sig.h"
#include "glilo_gui.h"
#include "glilo_common.h"
#include "../lilocommon/memwatch.h"


int main (int argc, char *argv[])
{
  gtk_set_locale ();

  gtk_init (&argc, &argv);

  textdomain("glilo");

  load_paths(); /* This will load paths to lilo data files */
  
  create_main_window (); /* Create main window & set up paths to pixmaps*/

  if (argc == 2) /* Open argument passed to program */
    open_lilo_file(argv[1]);
  else /* Open default lilo.conf file */
    open_lilo_file("/etc/lilo.conf");
  
  /*  open_lilo_file("../testfiles/lttest"); */
  
  gtk_main ();
  remove_paths(); /* This will clean up the paths to lilo data files */
  return 0;
}
