/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <libintl.h>

#include "glilo_menubar.h"
#include "pixmap_stuff.h"
#include "glilo_sig.h"

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>


/* Here we create the toolbar */
GtkWidget* create_toolbar (GtkWidget *window)
{
  GtkWidget *handlebox;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *buttonQuit;
  GtkWidget *buttonOpen;
  GtkWidget *buttonSave;
  GtkWidget *buttonPreview;
  GtkWidget *buttonSkoal;
  gboolean missing_xpm = FALSE;

  /*
   * First add the path to the pixmaps...
   */
  add_pixmap_directory("/usr/local/share/glilo");
  add_pixmap_directory("/usr/share/glilo");
  add_pixmap_directory("../pixmaps");
  add_pixmap_directory("./");


  handlebox = gtk_handle_box_new ();

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_show (toolbar);
  gtk_container_add (GTK_CONTAINER (handlebox), toolbar);

  
  tmp_toolbar_icon = create_pixmap (window, gettext("glilo_open.xpm"));
  if (tmp_toolbar_icon == NULL)
    missing_xpm = TRUE;
  buttonOpen = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Open",
                                gettext("Open up a new lilo.conf file"), NULL,
                                tmp_toolbar_icon, on_Open_lilo_file_activate, NULL);
  gtk_widget_show (buttonOpen);

  
  tmp_toolbar_icon = create_pixmap (window, gettext("glilo_save.xpm"));
  if (tmp_toolbar_icon == NULL)
    missing_xpm = TRUE;
  buttonSave = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Save",
                                gettext("Saves the current config to a file"), NULL,
                                tmp_toolbar_icon, on_Save_lilo_file_activate, NULL);
  gtk_widget_show (buttonSave);

  
  tmp_toolbar_icon = create_pixmap (window, gettext("glilo_preview.xpm"));
  if (tmp_toolbar_icon == NULL)
    missing_xpm = TRUE;
  buttonPreview = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Preview",
                                gettext("Shows a preview of the lilo.conf file that will be generated"), NULL,
                                tmp_toolbar_icon, on_Preview_activate, NULL);
  gtk_widget_show (buttonPreview);


  /*
   * Here we got ten lines with :
   * "Don't code and drink beer at the same time"-code
   */
  
  tmp_toolbar_icon = create_pixmap (window, gettext("glilo_skol.xpm"));
  if (tmp_toolbar_icon == NULL)
    missing_xpm = TRUE;
  buttonSkoal = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Skoal",
                                gettext("Is it saturday ? :)"), NULL,
                                tmp_toolbar_icon, on_About_activate, NULL);
  gtk_widget_show (buttonSkoal);


  tmp_toolbar_icon = create_pixmap (window, gettext("glilo_quit.xpm"));
  if (tmp_toolbar_icon == NULL)
    missing_xpm = TRUE;
  buttonQuit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Quit",
                                NULL, NULL,
                                tmp_toolbar_icon, on_Quit_activate, NULL);
  gtk_widget_show (buttonQuit);


  if (missing_xpm == TRUE) {
    g_print (gettext("Atleast one of the pixmaps couldn't be created...\n"));
    g_print (gettext("Setting style to both pixmap and text (ugly though)\n"));
    gtk_toolbar_set_style(GTK_TOOLBAR(toolbar),GTK_TOOLBAR_BOTH);
  }
  
  return handlebox;
}

/* eof */
