/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#ifndef __GLILO_SECTION_TREE_H__
#define __GLILO_SECTION_TREE_H__

#include <gtk/gtk.h>
#include "../lilocommon/llist.h"
#include "../lilocommon/lilo_data.h"
#include "../lilocommon/memwatch.h"
#include "glilo_gui.h"


typedef struct {
  int parent_id;         /* The ID of the lilo.conf file */
  int child_id;          /* The ID of the section within file */
  LILO_SECTION section;  /* Type of section */
} LILO_TREE_DATA;


LLIST *load_sections_from_file (char *filename,GLILO_GUI *gui);

void section_add_section (GLILO_GUI *gui, LILO_SECTION sec_type);

void remove_ctree_data (GLILO_GUI *gui);
void remove_ctree_item (GtkCTree *ctree, GtkCTreeNode *node);

char *get_section_name(int i);

void update_ctree_data(GtkCTree *ctree);


int get_last_section (void);
int get_last_section_id (void);

void set_last_section (int id);
void set_last_section_id (int id);


#endif
