/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <libintl.h>

#include "glilo_sig.h"
#include "glilo_section_tree.h"
#include "glilo_section.h"
#include "glilo_common.h"
#include "glilo_keyword.h"
#include "glilo_help.h"
#include "glilo_dialog_input.h"

#include "../lilocommon/lilo_keywords.h"
#include "../lilocommon/llist.h"

#define gettext_noop(x) (x) 

void
on_Quit_activate(GtkMenuItem *menuitem,gpointer data)
{
  gtk_main_quit();
  clean_things_up(main_gui); /* Remove all memory allocated for lilo_data */
  free (main_gui);
}


/*
void
on_Edit_activate(GtkMenuItem *menuitem, gpointer data)
{

}


void
on_Help_activate(GtkMenuItem *menuitem, gpointer data)
{

}
*/

void on_About_activate (GtkMenuItem *menuitem, gpointer data)
{
/*  gchar *mess = gettext_noop("GLilo and the CommonLilo parser/library is\n\
    \n  (c) Per Winkvist (Per.Winkvist@UK.COM) 1999\n\
    \n\nThis program is distributed under the GNU General Public License.");

    print_message (main_gui->textbar,gettext(mess));
    */
  
  gchar *mess = "Hey !!!!!!\n I'm interested in how the performance is when generating the keylist on slower computers.... \n \
Other performance issues are of interest too!!!\n\n\
Would a GNOME or KDE interface be good ??? Let me know!\n\n\
    GLilo and the CommonLilo parser/library is\n\n  (c) Per Winkvist (Per.Winkvist@UK.COM) 1999\n\
 \n\nThis program is distributed under the GNU General Public License.";      
 print_message(main_gui->textbar,mess); }

/*
 * Creates a new lilo.conf file with a couple of global options
 * and one image
 */

void on_New_lilo_file_activate (GtkMenuItem *menuitem, gpointer data)
{
  GtkCTreeNode *root;
  gchar *root_name = "untitled";

  /* Just show dialog when there are item in the lilotree */
  if (gtk_ctree_node_nth(main_gui->lilotree,0)) {
    dialog_input_show(gettext("This will remove the current things you are working with. Continue ?"),gettext("Confirmation!"));
    if (!dialog_was_okay_hit())
      return;
  }
  
  /* We will just allow one lilo.conf open at a time right now */
  if (main_gui->lilodata != NULL) {
    clean_things_up(main_gui);
    main_gui->lilodata = NULL;
  }

  root = gtk_ctree_insert_node (main_gui->lilotree,NULL,NULL,&root_name,5,
                                NULL,NULL,NULL,NULL,FALSE,FALSE);

  gtk_ctree_expand(main_gui->lilotree,root);

  main_gui->lilodata = llist_new();
  section_add_section (main_gui,LILO_GLOBAL);
  section_add_section (main_gui,LILO_IMAGE);
}

/*
 * We wanna open up a new lilo.conf file.... close the active (?) first
 */
void on_Open_lilo_file_activate (GtkMenuItem *menuitem, gpointer data)
{
  GtkWidget *filedialog;

 /* open_lilo_file ("lilo.conf"); */


  /* Create a new file dialog widget */
  filedialog = gtk_file_selection_new (gettext("Choose a lilo.conf file to open"));

  gtk_window_set_modal (GTK_WINDOW(filedialog),TRUE);
  
  gtk_signal_connect (GTK_OBJECT (filedialog), "destroy",
                                   (GtkSignalFunc) file_abandon, &filedialog);
  /* Connect the ok_button to the on_Open_lilo_file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->ok_button),
                                   "clicked", (GtkSignalFunc) on_Open_lilo_file_ok_sel, filedialog);

  /* Connect the cancel_button to file_abandon to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->cancel_button),
                                          "clicked", (GtkSignalFunc) file_abandon,GTK_OBJECT(filedialog));

  gtk_widget_show(filedialog);
  /* We don't want the user to do anything besides selecting
   * a file now...
   */
  gtk_main();
}

void on_Open_lilo_file_ok_sel (GtkWidget *widget, GtkFileSelection *filesel)
{
  g_print("Here : %s\n",gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel)));

  /* Open the file if it was valid */
  open_lilo_file (gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel)));

  /* Jump out of the filedialog event loop */
  file_abandon(GTK_WIDGET(filesel),NULL);
}


void on_Save_lilo_file_activate (GtkMenuItem *menuitem, gpointer data)
{
  g_print ("Global : %d\n",count_in_global(main_gui->lilodata));
  g_print ("Images : %d\n",count_images(main_gui->lilodata));
  g_print ("Others : %d\n",count_others(main_gui->lilodata));

  if (count_images(main_gui->lilodata) > 0)
    g_print("Image 1 has : %d items/keywords\n",count_in_image(main_gui->lilodata,0));
}


/*
 * Pop up a filedialog where user can specify a file
 * to save the current lilo.conf to
 */

void on_SaveAs_lilo_file_activate (GtkMenuItem *menuitem, gpointer data)
{
  GtkWidget *filedialog;

  /* Create a new file dialog widget */
  filedialog = gtk_file_selection_new (gettext("Specify a file to save lilo.conf data to"));

  gtk_window_set_modal (GTK_WINDOW(filedialog),TRUE);
  
  gtk_signal_connect (GTK_OBJECT (filedialog), "destroy",
                      (GtkSignalFunc) file_abandon, &filedialog);
  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->ok_button),
                      "clicked", (GtkSignalFunc) on_SaveAs_lilo_file_ok_sel, filedialog);

  /* Connect the cancel_button to file_abandon to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->cancel_button),
                             "clicked", (GtkSignalFunc) file_abandon,GTK_OBJECT(filedialog));

  gtk_widget_show(filedialog);
  /* We don't want the user to do anything besides selecting
   * a file now...
   */
  gtk_main();
  
}

/*
 * Saves the specified file from the filedialog if everything
 * is okay with file (permission,regular file)
 */
void on_SaveAs_lilo_file_ok_sel (GtkWidget *widget, GtkFileSelection *filesel)
{
  save_lilo_file (gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel)));
  file_abandon (GTK_WIDGET(filesel),NULL);
}


/*
 * Does a preview of the actual lilo.conf user is messing
 * around with
 */
void on_Preview_activate (GtkMenuItem *menuitem, gpointer data)
{
  LILO_ONE_OPTION *ptr;
  int i,max;
  int done_glob=0;
  char *buff;
  int size;

  gtk_text_freeze(GTK_TEXT(main_gui->textbar));

  gtk_text_backward_delete(GTK_TEXT(main_gui->textbar),
                          gtk_text_get_length(GTK_TEXT(main_gui->textbar)));

  if (main_gui->lilodata != NULL) {
    max = llist_get_size(main_gui->lilodata);
    for (i=0;i<max;i++) {
      ptr = llist_get_node(main_gui->lilodata,i);

      if ((strncmp(ptr->data_name,"image",5) == 0) ||
          (strncmp(ptr->data_name,"other",5) == 0)) {
        buff = calloc(strlen(ptr->data_name)+
                      strlen(ptr->data_args)+10,sizeof(char));

        /* Format and insert the string in the textbar */
        sprintf(buff,"\n%s = \"%s\"\n",ptr->data_name,ptr->data_args);
        gtk_text_insert(GTK_TEXT(main_gui->textbar),NULL,NULL,
                        NULL,buff,strlen(buff));

        free (buff);
        done_glob = 1; /* Printed image/other and done w/ globals */
      } else {
        /* We need to know how much mem to allocate */
        size = strlen(ptr->data_name);
        if (ptr->data_args != NULL)
          size += strlen(ptr->data_args);
        
        /* Then allocate the needed memory */
        buff = calloc (size + 10,sizeof(char));
        /* Now start to format the string to insert */
        if (done_glob != 0)
          strcpy(buff,"\t"); /* Lets indent if no more globals */

        strcat(buff,ptr->data_name);
        if (ptr->data_args != NULL) {/* do we have an argument ? */
          strcat(buff," = ");
          strcat(buff,ptr->data_args);
        }
        strcat (buff,"\n");
        /* Finally insert the string into the textbar */
        gtk_text_insert(GTK_TEXT(main_gui->textbar),NULL,NULL,
                        NULL,buff,strlen(buff));

        free (buff);
      }
    }
  }
  gtk_text_thaw(GTK_TEXT(main_gui->textbar));
}


/*
 * Users hits a section in the left lilotree
 */
void on_Lilo_tree_select (GtkCTree *ctree, GList *row, gint column)
{
  GtkCTreeNode *node;
  LILO_TREE_DATA *tree_data;

  
  node = gtk_ctree_node_nth (ctree,GTK_CLIST(ctree)->focus_row);
  tree_data = gtk_ctree_node_get_row_data(ctree,node);

  /*
  g_print("Parent : %p  Sibling : %p  Child : %p :  Row :%d\n",
          GTK_CTREE_ROW(node)->parent,
          GTK_CTREE_ROW(node)->sibling,
          GTK_CTREE_ROW(node)->children,
          GTK_CLIST(ctree)->focus_row);

          g_print("Treedata = %p\n",tree_data);
*/
  if (tree_data != NULL) {

    load_data_from_section(main_gui,tree_data->child_id,tree_data->section);

    /* We also want to show the first line in the modification box */
    section_view_part (main_gui->sectionlist,main_gui,
                       main_gui->lilodata,0);
  }
  else {/* We don't want any data in the sectionlist */
    remove_data_from_section(GTK_CLIST(main_gui->sectionlist));
    remove_data_from_keylist(GTK_CLIST(main_gui->keylist));
    print_message(main_gui->textbar,gettext("Please select a section from the upper left tree!"));
    hide_illegal_buttons(main_gui);
  }
}

/*
 * The left lilotree gets collapsed
 */
void on_Lilo_tree_collapse (GtkCTree *ctree,GList *row, gint column)
{
  GtkCTreeNode *node;

  /* Get the selected node */
  node = gtk_ctree_node_nth (ctree,GTK_CLIST(ctree)->focus_row);

  if (node != NULL && GTK_CTREE_ROW(node)->parent != NULL)
    /* Select the parent row for the current node */
    gtk_ctree_select (ctree,GTK_CTREE_ROW(node)->parent);

  /* Then remove everything in the sectionlist */
  remove_data_from_section(GTK_CLIST(main_gui->sectionlist));
  remove_data_from_keylist(GTK_CLIST(main_gui->keylist));
  print_message(main_gui->textbar,gettext("Stop collapsing me before I really collapse... :)"));
  hide_illegal_buttons(main_gui);

}

/*
 * Users hits the ctree where all keywords/arguments are
 */
void on_Section_list_select (GtkWidget *clist,gint row,gint col,
                             GdkEventButton *event, gpointer *data)
{
  gchar *text;

  gtk_clist_get_text((GtkCList *) clist,row,0,&text);

  section_view_part (clist,main_gui,main_gui->lilodata,row);
}

void on_Keylist_select (GtkWidget *clist,gint row,gint col,
                        GdkEventButton *event, gpointer *data)
{
  gchar *text;
  GtkCListRow *clist_row;


  clist_row = (g_list_nth (GTK_CLIST(main_gui->keylist)->row_list, row))->data;

  /*
   * We just wanna show the button if the word in the keylist
   * is supposed to be added
   */
  if (clist_row->state != GTK_STATE_INSENSITIVE)
    gtk_widget_set_sensitive(gtk_object_get_data(GTK_OBJECT(main_gui->mainwindow),"addbutton"),TRUE);
  else
    gtk_widget_set_sensitive(gtk_object_get_data(GTK_OBJECT(main_gui->mainwindow),"addbutton"),FALSE);


  gtk_clist_get_text((GtkCList *) clist,row,0,&text);

  show_help(main_gui->textbar,text);
}



/*
 * Updatebutton for a keyword/argument has been hit
 */
void on_Update_button_click (GtkWidget *widget,gpointer data)
{
  section_update(main_gui, main_gui->lilodata);
}

/*
 * User wants to add selected keyword to the current section
 */
void on_Add_button_click (GtkWidget *widget,gpointer data)
{

  if (((GtkCList *)main_gui->keylist)->focus_row > 0)
    section_add_option (main_gui);
}

/*
 * We will remove the highlighted selection in the ctree
 */
void on_Remove_button_click (GtkWidget *widget,gpointer data)
{
  GtkCTreeRow *row;

  row = GTK_CTREE_ROW (gtk_ctree_node_nth (main_gui->lilotree,
                                           GTK_CLIST(main_gui->lilotree)->focus_row));

  /* We wanna check if there are any nodes left to delete or just the parent */
  if ((row == NULL) || (row->parent == NULL &&
                        row->children == NULL && row->sibling == NULL)) {
    if (row != NULL) /* User hit delete and there are just the parent row left */
      clean_things_up(main_gui);
      
  } else
    section_remove_option(main_gui);
}


void on_GetFile_button_click (GtkWidget *widget,gpointer data)
{
  GtkWidget *filedialog;

  /* Create a new file dialog widget */
  filedialog = gtk_file_selection_new (gettext("Choose a file as the argument"));

  gtk_window_set_modal (GTK_WINDOW(filedialog),TRUE);
  
  gtk_signal_connect (GTK_OBJECT (filedialog), "destroy",
                      (GtkSignalFunc) file_abandon, &filedialog);
  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->ok_button),
                      "clicked", (GtkSignalFunc) on_GetFile_ok_sel, filedialog);

  /* Connect the cancel_button to file_abandon to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filedialog)->cancel_button),
                             "clicked", (GtkSignalFunc) file_abandon,GTK_OBJECT(filedialog));

  gtk_widget_show(filedialog);
  /* We don't want the user to do anything besides selecting
   * a file now...
   */
  gtk_main();
}


void on_GetFile_ok_sel (GtkWidget *widget, GtkFileSelection *filesel)
{
  GtkBoxChild *child_info=NULL;

  child_info = GTK_BOX(main_gui->argentry[0])->children->data;
  gtk_entry_set_text(GTK_ENTRY(child_info->widget),
                     gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel)));

  file_abandon(GTK_WIDGET(filesel),NULL);
}


void file_abandon (GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy (widget);
  gtk_main_quit(); /* Jump back to old event loop */
}


void open_lilo_file(char *filename)
{
  struct stat *buff = NULL;
  gchar *temp_str = NULL;
  const gchar err_str[] = gettext_noop("Error loading file");
  FILE *temp_file = NULL;

  g_print(gettext("Trying to open %s\n"),filename);
  if ((buff = malloc (sizeof(struct stat))) == NULL) {
    g_print("Couldn't allocate memory in %s : %d\n",__FILE__,__LINE__);
    free (buff);
    exit(EXIT_FAILURE);
  }
  
  /* First we'll do some checking if everything is okay with file */
  if (stat(filename,buff) != 0) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("Couldn't find the file!"));
    free (buff);
    return;
  }

  if (buff == NULL) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("I didn't find the requested file..."));
    free (buff);
    return;
  }
  
  if (!S_ISREG(buff->st_mode)) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("You tried to open something thats not a file!"));
    free (buff);
    return;
  }

  if (!(buff->st_mode & S_IRUSR)) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("You don't have permissions to read from the file!"));
    free (buff);
    return;
  }


 /* We will just allow one lilo.conf open at a time right now */
  if (main_gui->lilodata != NULL) {
    clean_things_up(main_gui);
    main_gui->lilodata = NULL;
  }

  main_gui->lilodata = NULL;     /* Indicate not opened yet */
  temp_file = fopen(filename,"r"); /* Test if we can open the file */

  if (temp_file != NULL) {        /* If we could open the file, lets parse it */
  /* Open the file and fill the gui */
    main_gui->lilodata = load_sections_from_file(filename,main_gui);
    fclose(temp_file);             /* Close the temp_file handle */
  }
    
  if (main_gui->lilodata != NULL) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("File loaded successfully!"));
    on_About_activate (NULL,NULL); /* Put the welcome & (c) text in the textbar */
  }
  else {
    temp_str = calloc (strlen(filename)+strlen(err_str)+5,sizeof(char));
    sprintf(temp_str,"%s \"%s\"",gettext(err_str),filename);
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                        temp_str);
    free (temp_str);
  }

  free (buff);
}


void save_lilo_file(char *filename)
{
  struct stat *buff = NULL;
  gboolean proceed = TRUE;

  if ((buff = malloc (sizeof(struct stat))) == NULL) {
    g_print("Couldn't allocate memory in %s : %d\n",__FILE__,__LINE__);
    free (buff);
    exit(EXIT_FAILURE);
  }

  /* First we'll do some checking if everything is okay with file */
  if (stat(filename,buff) == 0) { /* There was a file by that name... */

    g_print("buff->st_mode & S_IWUSR : %d\n",buff->st_mode & S_IWUSR);

    /*
     * The stat didn't work as I thought... It checks if the owner
     * of the file has right to write to file. Not current user
     */
    if (!(buff->st_mode & S_IWUSR)) { /* Check if we are allowed to write */
      gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                         gettext("You don't have permissions to write that file!"));
      proceed = FALSE;
    }
    else if (!S_ISREG(buff->st_mode)) { /* Check if file is a regular file */
      gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                         gettext("You tried to save to something that is not a valid file!"));
      proceed = FALSE;
    }
    else { /* Ask user if he wants to overwrite the specified file */
      gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                         gettext("Wanna overwrite that file ?"));
      dialog_input_show(gettext("Do you want to overwrite the current file ?"),gettext("Alert!"));
      if (! dialog_was_okay_hit())
        proceed = FALSE;
    }
  }

  free(buff);

  if (proceed == TRUE)
    save_to_lilo_file_real(filename);
}



void save_to_lilo_file_real(char *filename)
{
  LILO_ONE_OPTION *ptr;
  FILE *out_file;
  gchar section_text[100];/* Static buffer to hold "Kernel image XYZ123" */
  int image_count=1,other_count=1;
  int i,max;
  int done_glob=0;
  char *buff;
  int size;

  g_print (gettext("Writing lilo.conf data to %s...\n"),filename);

  if ((out_file = fopen(filename,"w")) == NULL) {
    gtk_label_set_text(GTK_LABEL(main_gui->statusbar),
                       gettext("Couldn't open file for writing!!!"));
    g_print(gettext("Couldn't open file (%s)for writing!!!"),filename);
    return;
  }

  /* Write some leading text for the global section */
  if (count_in_global(main_gui->lilodata) > 0) {
    strcpy(section_text,gettext("##### First we got some global settings...\n"));
    fputs(section_text,out_file);
  }
  
  if (main_gui->lilodata != NULL) {
    
    max = llist_get_size(main_gui->lilodata);
    for (i=0;i<max;i++) {
      ptr = llist_get_node(main_gui->lilodata,i);

      /* Is it a section ? */
      if ((strncmp(ptr->data_name,"image",5) == 0) ||
          (strncmp(ptr->data_name,"other",5) == 0)) {
        buff = calloc(strlen(ptr->data_name)+
                      strlen(ptr->data_args)+10,sizeof(char));

        /* First make a header for the section */
        if (strncmp(ptr->data_name,"image",5) == 0)
          sprintf(section_text,gettext("\n##### Kernel image %d"),image_count++);
        else
          sprintf(section_text,gettext("\n##### Other OS %d"),other_count++);

        /* Write the header */
        fputs(section_text,out_file);
        
        /* Format and copy the string to temp buffer*/
        if (ptr->data_argtype == ARG_QUOTE) /* with quotes */
          sprintf(buff,"\n%s = \"%s\"\n",ptr->data_name,ptr->data_args);
        else /* unquoted string */
          sprintf(buff,"\n%s = %s\n",ptr->data_name,ptr->data_args);

        fputs(buff,out_file);

        free (buff);
        done_glob = 1; /* Printed image/other and done w/ globals */
      } else {
        /* We need to know how much mem to allocate */
        size = strlen(ptr->data_name);
        if (ptr->data_args != NULL)
          size += strlen(ptr->data_args);
        
        /* Then allocate the needed memory */
        buff = calloc (size + 10,sizeof(char));
        /* Now start to format the string to insert */
        if (done_glob != 0)
          strcpy(buff,"\t"); /* Lets indent if no more globals */

        strcat(buff,ptr->data_name);
        if (ptr->data_argtype != ARG_NADA) {/* do we have an argument ? */
          strcat(buff," = ");
          if (ptr->data_argtype == ARG_QUOTE) {
            strcat(buff,"\"");
            strcat(buff,ptr->data_args);
            strcat(buff,"\"");
            /*sprintf(buff,"\t%s = \"%s\"",ptr->data_name,ptr->data_args);  append quotes */
          }
          else
            strcat(buff,ptr->data_args); /* skip the quotes */
        }
        strcat (buff,"\n");
        /* Finally insert the string into the textbar */
        fputs(buff,out_file);

        free (buff);
      }
    }
  }
  g_print(gettext("Done writing data!\n"));
  fclose (out_file);
}



void on_Add_global_activate (GtkMenuItem *menuitem, gpointer data)
{
  g_print("In add global now...\n");
  section_add_section (main_gui,LILO_GLOBAL);
  g_print("Done adding global...\n");
}


void on_Add_image_activate (GtkMenuItem *menuitem,
                          gpointer data)
{
  g_print("In add image now...\n");
  section_add_section (main_gui,LILO_IMAGE);
  g_print("Done in add image..\n");
}

void on_Add_other_activate (GtkMenuItem *menuitem,
                          gpointer data)
{
  g_print("In add image now...\n");
  section_add_section (main_gui,LILO_OTHER);
  g_print("Done in add image..\n");
  
}

void on_Report_bugs_activate (GtkMenuItem *menuitem,
                          gpointer data)
{
  gchar *mess = gettext_noop("*** Please report bugs that you might encounter. ***\n\n\
    Send an email to Per.Winkvist@UK.COM with a DETAILED report on how \n\
    you triggered the bug and the lilo.conf file you tried to load.");

  print_message(main_gui->textbar,gettext(mess));
}



/* eof */
