#include <stdlib.h>
#include "lilo_help.h"
#include "memwatch.h"
#include "lilo_common.h"

int main(int argc, char **args)
{
  char *temp;

  if (argc != 2) {
    printf("You need to supply _one_ keyword to search for!\n");
    printf("Like, \"lhelp vga\" or \"lhelp label\"\n");
    exit (EXIT_FAILURE);
  }

  add_possible_path ("/usr/share/glilo");
  add_possible_path ("/usr/local/share/glilo");
  add_possible_path ("./");


  temp = get_help(*(args+1),0);
  if (temp == NULL) {
    printf("Sorry, didn't find any help on \"%s\"\n",*(args+1));
    exit (EXIT_FAILURE);
  }
  printf("%s\n",temp);
  free (temp); /* And free the buff */

  free_possible_paths();
  exit (EXIT_SUCCESS);
}
