/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */

#ifndef __LILO_DATA_H__
#define __LILO_DATA_H__

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "llist.h"
#include "lilo_options.h"
#include "memwatch.h"


typedef struct {
  char *data_name;            /* The name of the option */
  char *data_args;            /* List of the args */
  LLIST *data_pre_req;        /* The list of pre_req's for it */
  LLIST *data_post_req;       /* The list of post req's */
  LILO_ARG_TYPE data_argtype; /* What type of arg is it ? */
  LLIST *carg_words;          /* Holds a list of ID/ID-NAME */
} LILO_ONE_OPTION;


/* Functions */

void free_lilo_data_one (LILO_ONE_OPTION *ptr);
void free_lilo_data(LLIST *lilo_data);

int get_common_node (LLIST *lilo_data, char *section_name, int image);
int get_image_node (LLIST *lilo_data, int image);
int get_other_node (LLIST *lilo_data, int other);
#define get_global_node(lilo_data) (0)

int count_common (LLIST *lilo_data, char *section_name);
int count_images (LLIST *lilo_data);
int count_others (LLIST *lilo_data);

int count_in_common (LLIST *lilo_data, int start_node);
int count_in_global (LLIST *global);
int count_in_image (LLIST *image, int i);
int count_in_other (LLIST *other, int i);

LLIST *merge_data (LLIST *src_image, LLIST *image);
LLIST *new_data (char *keyword, char *arg);

char *merge_args (char *args, char *arg);

/* Fills up the LILO_ONE_OPTION with req's */
void fill_data_with_reqs(LLIST *lilo_data);
void fill_one_data_with_reqs(LILO_ONE_OPTION *ptr);

void print_data (LLIST *lilo_data);
#endif

