/* Code written by Per Winkvist (Per.Winkvist@UK.COM)
 * In 1999
 * See README and COPYING for further details
 *
 */


#ifndef __LILO_KEYWORDS_H__
#define __LILO_KEYWORDS_H__

#include "llist.h"

typedef struct {
  char *name;               /* The name of the keyword */
  LLIST *childs;            /* The list with POSSIBLE_KEYWORDS for 'name' */
  int group;                /* Is this supposed to be 'grouped' with previously (post)*/
  int enabled;              /* If it is possible to use this word now */
} POSSIBLE_KEYWORDS;

typedef enum {
  KEYWORD_ENABLED,  /* 0 */
  KEYWORD_DISABLED, /* 1 */
  KEYWORD_USED      /* 2 */
} KEYWORD_STATUS;


/* Returns a struct (POSSIBLE_KEYWORDS) with possible keywords
 * for the lilo_data structure's section...
 * Like, what keywords can we add or be used for section 2
 *
 * sec_name : type of section (LILO_GLOBAL, LILO_IMAGE, LILO_OTHER)
 * section : Section 'section' within the 'sec_name'...
 */
LLIST *get_keywords_for(LLIST *lilo_data,char *sec_name,int section);
void free_keywords_for(LLIST *keywords);

void print_keywords_for(LLIST *keywords);

#endif
