/* A simple linked list
 * Author : Per Winkvist - 98
 * Version 1998-12-01
 */

#ifndef __LLIST_H__
#define __LLIST_H__

#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#include <malloc.h>
#include "memwatch.h"


typedef void (*LL_FUNC_PTR) (void *dataptr);

struct LLIST_NODE_DEF {
  void *dataptr;

  struct LLIST_NODE_DEF *next;
};

typedef struct LLIST_NODE_DEF LLIST_NODE;


struct LLIST_DEF {
  LLIST_NODE *head;
  int count; /* Old habits, see how many nodes there are */
};

typedef struct LLIST_DEF LLIST;


LLIST *llist_new (void);
void llist_free (LLIST *ll);
int llist_insert (LLIST *ll, void *data);
int llist_insert_at(LLIST *ll,void *data,int position);
void *llist_get_min (LLIST *ll);
void *llist_pop_min (LLIST *ll);
int llist_get_size (LLIST *ll);
void *llist_get_node (LLIST *ll, int node);
void *llist_pop_node (LLIST *ll, int node);
void llist_for_each (LLIST *ll, LL_FUNC_PTR);

LLIST *llist_merge_lists (LLIST *first, LLIST *second);

#endif
