/* A linked list with pars messages (errors & warnings)
 *
 * Author : Per Winkvist (Per.Winkvist@UK.COM) - 98
 */

#include <libintl.h>

#include "message.h"
#include "memwatch.h"

/* I'll use a global linkedlist for this file.
 * The *messll should just be used internally in message.c
 * since the message routines takes care of the rest.
 */
LLIST *messll;


void createmess(void)
{
  messll = llist_new ();
}


void freemess (void)
{
  char *data;
  int i,size;

  size = llist_get_size(messll);
  for (i=0;i<size;i++) {
    data = llist_pop_min(messll);
    free (data);
  }
  
  llist_free (messll);
}


int messcount(void)
{
  return llist_get_size(messll);
}

void insertmess(char *text)
{
  char *newmess;

  if ((newmess = calloc (strlen(text)+1,sizeof(char))) == NULL) {
    printf("Couln't allocate memory in %s at %d!\n",__FILE__,__LINE__);
    exit(EXIT_FAILURE);
  }
  strcpy(newmess,text);
  
  llist_insert(messll,newmess);
}


void INTERNAL_printmess (char *text)
{
  printf("%s\n",text);

}

void printmess(void)
{
  printf(gettext("______ LIST OF ERRORS AND WARNINGS ______\n"));
         
  if (llist_get_size(messll) < 1)
    printf(gettext("No errors or warnings were found!\n"));
  else
    llist_for_each(messll,(void *)INTERNAL_printmess);
}

LLIST *getmesslist(void)
{
  return messll;
}

void setmesslist(LLIST *mlist)
{
  messll = mlist;
}
