/* Function for handling a symbol table. Its better to return
 * a number indicating position in symbol tablel then there
 * is to save it and return pointer with yylval.
 * Cause I have found it easier to catch memleaks with a symtab
 *
 * Author : Per Winkvist (Per.Winkvist@UK.COM)
 */
 

#ifndef __SYMTAB_H__
#define __SYMTAB_H__

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "llist.h"
#include "memwatch.h"

LLIST *create_symtab (void);
void free_symtab (LLIST *symtab);

int insert_symbol (LLIST *symtab, char *text);
char *get_symbol_at_pos (LLIST *symtab, int pos);
int find_symbol (LLIST *symtab, char *symbol,int is_case);
void print_symtab (LLIST *symtab);
#endif
